t / test-lib.shon commit Introduce sane_unset and use it to ensure proper && chaining (00648ba)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset GIT_EDITOR
  47unset AUTHOR_DATE
  48unset AUTHOR_EMAIL
  49unset AUTHOR_NAME
  50unset COMMIT_AUTHOR_EMAIL
  51unset COMMIT_AUTHOR_NAME
  52unset EMAIL
  53unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  54unset GIT_AUTHOR_DATE
  55GIT_AUTHOR_EMAIL=author@example.com
  56GIT_AUTHOR_NAME='A U Thor'
  57unset GIT_COMMITTER_DATE
  58GIT_COMMITTER_EMAIL=committer@example.com
  59GIT_COMMITTER_NAME='C O Mitter'
  60unset GIT_DIFF_OPTS
  61unset GIT_DIR
  62unset GIT_WORK_TREE
  63unset GIT_EXTERNAL_DIFF
  64unset GIT_INDEX_FILE
  65unset GIT_OBJECT_DIRECTORY
  66unset GIT_CEILING_DIRECTORIES
  67unset SHA1_FILE_DIRECTORIES
  68unset SHA1_FILE_DIRECTORY
  69unset GIT_NOTES_REF
  70unset GIT_NOTES_DISPLAY_REF
  71unset GIT_NOTES_REWRITE_REF
  72unset GIT_NOTES_REWRITE_MODE
  73GIT_MERGE_VERBOSITY=5
  74export GIT_MERGE_VERBOSITY
  75export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  76export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  77export EDITOR
  78
  79# Protect ourselves from common misconfiguration to export
  80# CDPATH into the environment
  81unset CDPATH
  82
  83unset GREP_OPTIONS
  84
  85case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  86        1|2|true)
  87                echo "* warning: Some tests will not work if GIT_TRACE" \
  88                        "is set as to trace on STDERR ! *"
  89                echo "* warning: Please set GIT_TRACE to something" \
  90                        "other than 1, 2 or true ! *"
  91                ;;
  92esac
  93
  94# Convenience
  95#
  96# A regexp to match 5 and 40 hexdigits
  97_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  98_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  99
 100# Each test should start with something like this, after copyright notices:
 101#
 102# test_description='Description of this test...
 103# This test checks if command xyzzy does the right thing...
 104# '
 105# . ./test-lib.sh
 106[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 107                TERM=$ORIGINAL_TERM &&
 108                export TERM &&
 109                [ -t 1 ] &&
 110                tput bold >/dev/null 2>&1 &&
 111                tput setaf 1 >/dev/null 2>&1 &&
 112                tput sgr0 >/dev/null 2>&1
 113        ) &&
 114        color=t
 115
 116while test "$#" -ne 0
 117do
 118        case "$1" in
 119        -d|--d|--de|--deb|--debu|--debug)
 120                debug=t; shift ;;
 121        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 122                immediate=t; shift ;;
 123        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 124                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 125        -h|--h|--he|--hel|--help)
 126                help=t; shift ;;
 127        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 128                verbose=t; shift ;;
 129        -q|--q|--qu|--qui|--quie|--quiet)
 130                # Ignore --quiet under a TAP::Harness. Saying how many tests
 131                # passed without the ok/not ok details is always an error.
 132                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 133        --with-dashes)
 134                with_dashes=t; shift ;;
 135        --no-color)
 136                color=; shift ;;
 137        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 138                valgrind=t; verbose=t; shift ;;
 139        --tee)
 140                shift ;; # was handled already
 141        --root=*)
 142                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 143                shift ;;
 144        *)
 145                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 146        esac
 147done
 148
 149if test -n "$color"; then
 150        say_color () {
 151                (
 152                TERM=$ORIGINAL_TERM
 153                export TERM
 154                case "$1" in
 155                        error) tput bold; tput setaf 1;; # bold red
 156                        skip)  tput bold; tput setaf 2;; # bold green
 157                        pass)  tput setaf 2;;            # green
 158                        info)  tput setaf 3;;            # brown
 159                        *) test -n "$quiet" && return;;
 160                esac
 161                shift
 162                printf "%s" "$*"
 163                tput sgr0
 164                echo
 165                )
 166        }
 167else
 168        say_color() {
 169                test -z "$1" && test -n "$quiet" && return
 170                shift
 171                echo "$*"
 172        }
 173fi
 174
 175error () {
 176        say_color error "error: $*"
 177        GIT_EXIT_OK=t
 178        exit 1
 179}
 180
 181say () {
 182        say_color info "$*"
 183}
 184
 185test "${test_description}" != "" ||
 186error "Test script did not set test_description."
 187
 188if test "$help" = "t"
 189then
 190        echo "$test_description"
 191        exit 0
 192fi
 193
 194exec 5>&1
 195if test "$verbose" = "t"
 196then
 197        exec 4>&2 3>&1
 198else
 199        exec 4>/dev/null 3>/dev/null
 200fi
 201
 202test_failure=0
 203test_count=0
 204test_fixed=0
 205test_broken=0
 206test_success=0
 207
 208test_external_has_tap=0
 209
 210die () {
 211        code=$?
 212        if test -n "$GIT_EXIT_OK"
 213        then
 214                exit $code
 215        else
 216                echo >&5 "FATAL: Unexpected exit with code $code"
 217                exit 1
 218        fi
 219}
 220
 221GIT_EXIT_OK=
 222trap 'die' EXIT
 223
 224# The semantics of the editor variables are that of invoking
 225# sh -c "$EDITOR \"$@\"" files ...
 226#
 227# If our trash directory contains shell metacharacters, they will be
 228# interpreted if we just set $EDITOR directly, so do a little dance with
 229# environment variables to work around this.
 230#
 231# In particular, quoting isn't enough, as the path may contain the same quote
 232# that we're using.
 233test_set_editor () {
 234        FAKE_EDITOR="$1"
 235        export FAKE_EDITOR
 236        EDITOR='"$FAKE_EDITOR"'
 237        export EDITOR
 238}
 239
 240test_decode_color () {
 241        sed     -e 's/.\[1m/<WHITE>/g' \
 242                -e 's/.\[31m/<RED>/g' \
 243                -e 's/.\[32m/<GREEN>/g' \
 244                -e 's/.\[33m/<YELLOW>/g' \
 245                -e 's/.\[34m/<BLUE>/g' \
 246                -e 's/.\[35m/<MAGENTA>/g' \
 247                -e 's/.\[36m/<CYAN>/g' \
 248                -e 's/.\[m/<RESET>/g'
 249}
 250
 251q_to_nul () {
 252        perl -pe 'y/Q/\000/'
 253}
 254
 255q_to_cr () {
 256        tr Q '\015'
 257}
 258
 259q_to_tab () {
 260        tr Q '\011'
 261}
 262
 263append_cr () {
 264        sed -e 's/$/Q/' | tr Q '\015'
 265}
 266
 267remove_cr () {
 268        tr '\015' Q | sed -e 's/Q$//'
 269}
 270
 271# In some bourne shell implementations, the "unset" builtin returns
 272# nonzero status when a variable to be unset was not set in the first
 273# place.
 274#
 275# Use sane_unset when that should not be considered an error.
 276
 277sane_unset () {
 278        unset "$@"
 279        return 0
 280}
 281
 282test_tick () {
 283        if test -z "${test_tick+set}"
 284        then
 285                test_tick=1112911993
 286        else
 287                test_tick=$(($test_tick + 60))
 288        fi
 289        GIT_COMMITTER_DATE="$test_tick -0700"
 290        GIT_AUTHOR_DATE="$test_tick -0700"
 291        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 292}
 293
 294# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 295#
 296# This will commit a file with the given contents and the given commit
 297# message.  It will also add a tag with <message> as name.
 298#
 299# Both <file> and <contents> default to <message>.
 300
 301test_commit () {
 302        file=${2:-"$1.t"}
 303        echo "${3-$1}" > "$file" &&
 304        git add "$file" &&
 305        test_tick &&
 306        git commit -m "$1" &&
 307        git tag "$1"
 308}
 309
 310# Call test_merge with the arguments "<message> <commit>", where <commit>
 311# can be a tag pointing to the commit-to-merge.
 312
 313test_merge () {
 314        test_tick &&
 315        git merge -m "$1" "$2" &&
 316        git tag "$1"
 317}
 318
 319# This function helps systems where core.filemode=false is set.
 320# Use it instead of plain 'chmod +x' to set or unset the executable bit
 321# of a file in the working directory and add it to the index.
 322
 323test_chmod () {
 324        chmod "$@" &&
 325        git update-index --add "--chmod=$@"
 326}
 327
 328# Use test_set_prereq to tell that a particular prerequisite is available.
 329# The prerequisite can later be checked for in two ways:
 330#
 331# - Explicitly using test_have_prereq.
 332#
 333# - Implicitly by specifying the prerequisite tag in the calls to
 334#   test_expect_{success,failure,code}.
 335#
 336# The single parameter is the prerequisite tag (a simple word, in all
 337# capital letters by convention).
 338
 339test_set_prereq () {
 340        satisfied="$satisfied$1 "
 341}
 342satisfied=" "
 343
 344test_have_prereq () {
 345        # prerequisites can be concatenated with ','
 346        save_IFS=$IFS
 347        IFS=,
 348        set -- $*
 349        IFS=$save_IFS
 350
 351        total_prereq=0
 352        ok_prereq=0
 353        missing_prereq=
 354
 355        for prerequisite
 356        do
 357                total_prereq=$(($total_prereq + 1))
 358                case $satisfied in
 359                *" $prerequisite "*)
 360                        ok_prereq=$(($ok_prereq + 1))
 361                        ;;
 362                *)
 363                        # Keep a list of missing prerequisites
 364                        if test -z "$missing_prereq"
 365                        then
 366                                missing_prereq=$prerequisite
 367                        else
 368                                missing_prereq="$prerequisite,$missing_prereq"
 369                        fi
 370                esac
 371        done
 372
 373        test $total_prereq = $ok_prereq
 374}
 375
 376# You are not expected to call test_ok_ and test_failure_ directly, use
 377# the text_expect_* functions instead.
 378
 379test_ok_ () {
 380        test_success=$(($test_success + 1))
 381        say_color "" "ok $test_count - $@"
 382}
 383
 384test_failure_ () {
 385        test_failure=$(($test_failure + 1))
 386        say_color error "not ok - $test_count $1"
 387        shift
 388        echo "$@" | sed -e 's/^/#       /'
 389        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 390}
 391
 392test_known_broken_ok_ () {
 393        test_fixed=$(($test_fixed+1))
 394        say_color "" "ok $test_count - $@ # TODO known breakage"
 395}
 396
 397test_known_broken_failure_ () {
 398        test_broken=$(($test_broken+1))
 399        say_color skip "not ok $test_count - $@ # TODO known breakage"
 400}
 401
 402test_debug () {
 403        test "$debug" = "" || eval "$1"
 404}
 405
 406test_run_ () {
 407        test_cleanup=:
 408        eval >&3 2>&4 "$1"
 409        eval_ret=$?
 410        eval >&3 2>&4 "$test_cleanup"
 411        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 412                echo ""
 413        fi
 414        return 0
 415}
 416
 417test_skip () {
 418        test_count=$(($test_count+1))
 419        to_skip=
 420        for skp in $GIT_SKIP_TESTS
 421        do
 422                case $this_test.$test_count in
 423                $skp)
 424                        to_skip=t
 425                        break
 426                esac
 427        done
 428        if test -z "$to_skip" && test -n "$prereq" &&
 429           ! test_have_prereq "$prereq"
 430        then
 431                to_skip=t
 432        fi
 433        case "$to_skip" in
 434        t)
 435                of_prereq=
 436                if test "$missing_prereq" != "$prereq"
 437                then
 438                        of_prereq=" of $prereq"
 439                fi
 440
 441                say_color skip >&3 "skipping test: $@"
 442                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 443                : true
 444                ;;
 445        *)
 446                false
 447                ;;
 448        esac
 449}
 450
 451test_expect_failure () {
 452        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 453        test "$#" = 2 ||
 454        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 455        if ! test_skip "$@"
 456        then
 457                say >&3 "checking known breakage: $2"
 458                test_run_ "$2"
 459                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 460                then
 461                        test_known_broken_ok_ "$1"
 462                else
 463                        test_known_broken_failure_ "$1"
 464                fi
 465        fi
 466        echo >&3 ""
 467}
 468
 469test_expect_success () {
 470        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 471        test "$#" = 2 ||
 472        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 473        if ! test_skip "$@"
 474        then
 475                say >&3 "expecting success: $2"
 476                test_run_ "$2"
 477                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 478                then
 479                        test_ok_ "$1"
 480                else
 481                        test_failure_ "$@"
 482                fi
 483        fi
 484        echo >&3 ""
 485}
 486
 487# test_external runs external test scripts that provide continuous
 488# test output about their progress, and succeeds/fails on
 489# zero/non-zero exit code.  It outputs the test output on stdout even
 490# in non-verbose mode, and announces the external script with "# run
 491# <n>: ..." before running it.  When providing relative paths, keep in
 492# mind that all scripts run in "trash directory".
 493# Usage: test_external description command arguments...
 494# Example: test_external 'Perl API' perl ../path/to/test.pl
 495test_external () {
 496        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 497        test "$#" = 3 ||
 498        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 499        descr="$1"
 500        shift
 501        if ! test_skip "$descr" "$@"
 502        then
 503                # Announce the script to reduce confusion about the
 504                # test output that follows.
 505                say_color "" "# run $test_count: $descr ($*)"
 506                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 507                # to be able to use them in script
 508                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 509                # Run command; redirect its stderr to &4 as in
 510                # test_run_, but keep its stdout on our stdout even in
 511                # non-verbose mode.
 512                "$@" 2>&4
 513                if [ "$?" = 0 ]
 514                then
 515                        if test $test_external_has_tap -eq 0; then
 516                                test_ok_ "$descr"
 517                        else
 518                                say_color "" "# test_external test $descr was ok"
 519                                test_success=$(($test_success + 1))
 520                        fi
 521                else
 522                        if test $test_external_has_tap -eq 0; then
 523                                test_failure_ "$descr" "$@"
 524                        else
 525                                say_color error "# test_external test $descr failed: $@"
 526                                test_failure=$(($test_failure + 1))
 527                        fi
 528                fi
 529        fi
 530}
 531
 532# Like test_external, but in addition tests that the command generated
 533# no output on stderr.
 534test_external_without_stderr () {
 535        # The temporary file has no (and must have no) security
 536        # implications.
 537        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 538        stderr="$tmp/git-external-stderr.$$.tmp"
 539        test_external "$@" 4> "$stderr"
 540        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 541        descr="no stderr: $1"
 542        shift
 543        say >&3 "# expecting no stderr from previous command"
 544        if [ ! -s "$stderr" ]; then
 545                rm "$stderr"
 546
 547                if test $test_external_has_tap -eq 0; then
 548                        test_ok_ "$descr"
 549                else
 550                        say_color "" "# test_external_without_stderr test $descr was ok"
 551                        test_success=$(($test_success + 1))
 552                fi
 553        else
 554                if [ "$verbose" = t ]; then
 555                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 556                else
 557                        output=
 558                fi
 559                # rm first in case test_failure exits.
 560                rm "$stderr"
 561                if test $test_external_has_tap -eq 0; then
 562                        test_failure_ "$descr" "$@" "$output"
 563                else
 564                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 565                        test_failure=$(($test_failure + 1))
 566                fi
 567        fi
 568}
 569
 570# debugging-friendly alternatives to "test [-f|-d|-e]"
 571# The commands test the existence or non-existence of $1. $2 can be
 572# given to provide a more precise diagnosis.
 573test_path_is_file () {
 574        if ! [ -f "$1" ]
 575        then
 576                echo "File $1 doesn't exist. $*"
 577                false
 578        fi
 579}
 580
 581test_path_is_dir () {
 582        if ! [ -d "$1" ]
 583        then
 584                echo "Directory $1 doesn't exist. $*"
 585                false
 586        fi
 587}
 588
 589test_path_is_missing () {
 590        if [ -e "$1" ]
 591        then
 592                echo "Path exists:"
 593                ls -ld "$1"
 594                if [ $# -ge 1 ]; then
 595                        echo "$*"
 596                fi
 597                false
 598        fi
 599}
 600
 601
 602# This is not among top-level (test_expect_success | test_expect_failure)
 603# but is a prefix that can be used in the test script, like:
 604#
 605#       test_expect_success 'complain and die' '
 606#           do something &&
 607#           do something else &&
 608#           test_must_fail git checkout ../outerspace
 609#       '
 610#
 611# Writing this as "! git checkout ../outerspace" is wrong, because
 612# the failure could be due to a segv.  We want a controlled failure.
 613
 614test_must_fail () {
 615        "$@"
 616        exit_code=$?
 617        if test $exit_code = 0; then
 618                echo >&2 "test_must_fail: command succeeded: $*"
 619                return 1
 620        elif test $exit_code -gt 129 -a $exit_code -le 192; then
 621                echo >&2 "test_must_fail: died by signal: $*"
 622                return 1
 623        elif test $exit_code = 127; then
 624                echo >&2 "test_must_fail: command not found: $*"
 625                return 1
 626        fi
 627        return 0
 628}
 629
 630# Similar to test_must_fail, but tolerates success, too.  This is
 631# meant to be used in contexts like:
 632#
 633#       test_expect_success 'some command works without configuration' '
 634#               test_might_fail git config --unset all.configuration &&
 635#               do something
 636#       '
 637#
 638# Writing "git config --unset all.configuration || :" would be wrong,
 639# because we want to notice if it fails due to segv.
 640
 641test_might_fail () {
 642        "$@"
 643        exit_code=$?
 644        if test $exit_code -gt 129 -a $exit_code -le 192; then
 645                echo >&2 "test_might_fail: died by signal: $*"
 646                return 1
 647        elif test $exit_code = 127; then
 648                echo >&2 "test_might_fail: command not found: $*"
 649                return 1
 650        fi
 651        return 0
 652}
 653
 654# Similar to test_must_fail and test_might_fail, but check that a
 655# given command exited with a given exit code. Meant to be used as:
 656#
 657#       test_expect_success 'Merge with d/f conflicts' '
 658#               test_expect_code 1 git merge "merge msg" B master
 659#       '
 660
 661test_expect_code () {
 662        want_code=$1
 663        shift
 664        "$@"
 665        exit_code=$?
 666        if test $exit_code = $want_code
 667        then
 668                echo >&2 "test_expect_code: command exited with $exit_code: $*"
 669                return 0
 670        else
 671                echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 672                return 1
 673        fi
 674}
 675
 676# test_cmp is a helper function to compare actual and expected output.
 677# You can use it like:
 678#
 679#       test_expect_success 'foo works' '
 680#               echo expected >expected &&
 681#               foo >actual &&
 682#               test_cmp expected actual
 683#       '
 684#
 685# This could be written as either "cmp" or "diff -u", but:
 686# - cmp's output is not nearly as easy to read as diff -u
 687# - not all diff versions understand "-u"
 688
 689test_cmp() {
 690        $GIT_TEST_CMP "$@"
 691}
 692
 693# This function can be used to schedule some commands to be run
 694# unconditionally at the end of the test to restore sanity:
 695#
 696#       test_expect_success 'test core.capslock' '
 697#               git config core.capslock true &&
 698#               test_when_finished "git config --unset core.capslock" &&
 699#               hello world
 700#       '
 701#
 702# That would be roughly equivalent to
 703#
 704#       test_expect_success 'test core.capslock' '
 705#               git config core.capslock true &&
 706#               hello world
 707#               git config --unset core.capslock
 708#       '
 709#
 710# except that the greeting and config --unset must both succeed for
 711# the test to pass.
 712
 713test_when_finished () {
 714        test_cleanup="{ $*
 715                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 716}
 717
 718# Most tests can use the created repository, but some may need to create more.
 719# Usage: test_create_repo <directory>
 720test_create_repo () {
 721        test "$#" = 1 ||
 722        error "bug in the test script: not 1 parameter to test-create-repo"
 723        repo="$1"
 724        mkdir -p "$repo"
 725        (
 726                cd "$repo" || error "Cannot setup test environment"
 727                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 728                error "cannot run git init -- have you built things yet?"
 729                mv .git/hooks .git/hooks-disabled
 730        ) || exit
 731}
 732
 733test_done () {
 734        GIT_EXIT_OK=t
 735
 736        if test -z "$HARNESS_ACTIVE"; then
 737                test_results_dir="$TEST_DIRECTORY/test-results"
 738                mkdir -p "$test_results_dir"
 739                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 740
 741                echo "total $test_count" >> $test_results_path
 742                echo "success $test_success" >> $test_results_path
 743                echo "fixed $test_fixed" >> $test_results_path
 744                echo "broken $test_broken" >> $test_results_path
 745                echo "failed $test_failure" >> $test_results_path
 746                echo "" >> $test_results_path
 747        fi
 748
 749        if test "$test_fixed" != 0
 750        then
 751                say_color pass "# fixed $test_fixed known breakage(s)"
 752        fi
 753        if test "$test_broken" != 0
 754        then
 755                say_color error "# still have $test_broken known breakage(s)"
 756                msg="remaining $(($test_count-$test_broken)) test(s)"
 757        else
 758                msg="$test_count test(s)"
 759        fi
 760        case "$test_failure" in
 761        0)
 762                # Maybe print SKIP message
 763                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 764
 765                if test $test_external_has_tap -eq 0; then
 766                        say_color pass "# passed all $msg"
 767                        say "1..$test_count$skip_all"
 768                fi
 769
 770                test -d "$remove_trash" &&
 771                cd "$(dirname "$remove_trash")" &&
 772                rm -rf "$(basename "$remove_trash")"
 773
 774                exit 0 ;;
 775
 776        *)
 777                if test $test_external_has_tap -eq 0; then
 778                        say_color error "# failed $test_failure among $msg"
 779                        say "1..$test_count"
 780                fi
 781
 782                exit 1 ;;
 783
 784        esac
 785}
 786
 787# Test the binaries we have just built.  The tests are kept in
 788# t/ subdirectory and are run in 'trash directory' subdirectory.
 789if test -z "$TEST_DIRECTORY"
 790then
 791        # We allow tests to override this, in case they want to run tests
 792        # outside of t/, e.g. for running tests on the test library
 793        # itself.
 794        TEST_DIRECTORY=$(pwd)
 795fi
 796GIT_BUILD_DIR="$TEST_DIRECTORY"/..
 797
 798if test -n "$valgrind"
 799then
 800        make_symlink () {
 801                test -h "$2" &&
 802                test "$1" = "$(readlink "$2")" || {
 803                        # be super paranoid
 804                        if mkdir "$2".lock
 805                        then
 806                                rm -f "$2" &&
 807                                ln -s "$1" "$2" &&
 808                                rm -r "$2".lock
 809                        else
 810                                while test -d "$2".lock
 811                                do
 812                                        say "Waiting for lock on $2."
 813                                        sleep 1
 814                                done
 815                        fi
 816                }
 817        }
 818
 819        make_valgrind_symlink () {
 820                # handle only executables
 821                test -x "$1" || return
 822
 823                base=$(basename "$1")
 824                symlink_target=$GIT_BUILD_DIR/$base
 825                # do not override scripts
 826                if test -x "$symlink_target" &&
 827                    test ! -d "$symlink_target" &&
 828                    test "#!" != "$(head -c 2 < "$symlink_target")"
 829                then
 830                        symlink_target=../valgrind.sh
 831                fi
 832                case "$base" in
 833                *.sh|*.perl)
 834                        symlink_target=../unprocessed-script
 835                esac
 836                # create the link, or replace it if it is out of date
 837                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 838        }
 839
 840        # override all git executables in TEST_DIRECTORY/..
 841        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 842        mkdir -p "$GIT_VALGRIND"/bin
 843        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 844        do
 845                make_valgrind_symlink $file
 846        done
 847        OLDIFS=$IFS
 848        IFS=:
 849        for path in $PATH
 850        do
 851                ls "$path"/git-* 2> /dev/null |
 852                while read file
 853                do
 854                        make_valgrind_symlink "$file"
 855                done
 856        done
 857        IFS=$OLDIFS
 858        PATH=$GIT_VALGRIND/bin:$PATH
 859        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 860        export GIT_VALGRIND
 861elif test -n "$GIT_TEST_INSTALLED" ; then
 862        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 863        error "Cannot run git from $GIT_TEST_INSTALLED."
 864        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 865        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 866else # normal case, use ../bin-wrappers only unless $with_dashes:
 867        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 868        if ! test -x "$git_bin_dir/git" ; then
 869                if test -z "$with_dashes" ; then
 870                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 871                fi
 872                with_dashes=t
 873        fi
 874        PATH="$git_bin_dir:$PATH"
 875        GIT_EXEC_PATH=$GIT_BUILD_DIR
 876        if test -n "$with_dashes" ; then
 877                PATH="$GIT_BUILD_DIR:$PATH"
 878        fi
 879fi
 880GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 881unset GIT_CONFIG
 882GIT_CONFIG_NOSYSTEM=1
 883GIT_CONFIG_NOGLOBAL=1
 884export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 885
 886. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
 887
 888if test -z "$GIT_TEST_CMP"
 889then
 890        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 891        then
 892                GIT_TEST_CMP="$DIFF -c"
 893        else
 894                GIT_TEST_CMP="$DIFF -u"
 895        fi
 896fi
 897
 898GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 899export GITPERLLIB
 900test -d "$GIT_BUILD_DIR"/templates/blt || {
 901        error "You haven't built things yet, have you?"
 902}
 903
 904if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 905then
 906        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 907        export GITPYTHONLIB
 908        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 909                error "You haven't built git_remote_helpers yet, have you?"
 910        }
 911fi
 912
 913if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
 914        echo >&2 'You need to build test-chmtime:'
 915        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 916        exit 1
 917fi
 918
 919# Test repository
 920test="trash directory.$(basename "$0" .sh)"
 921test -n "$root" && test="$root/$test"
 922case "$test" in
 923/*) TRASH_DIRECTORY="$test" ;;
 924 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 925esac
 926test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 927rm -fr "$test" || {
 928        GIT_EXIT_OK=t
 929        echo >&5 "FATAL: Cannot prepare test area"
 930        exit 1
 931}
 932
 933test_create_repo "$test"
 934# Use -P to resolve symlinks in our working directory so that the cwd
 935# in subprocesses like git equals our $PWD (for pathname comparisons).
 936cd -P "$test" || exit 1
 937
 938HOME=$(pwd)
 939export HOME
 940
 941this_test=${0##*/}
 942this_test=${this_test%%-*}
 943for skp in $GIT_SKIP_TESTS
 944do
 945        case "$this_test" in
 946        $skp)
 947                say_color skip >&3 "skipping test $this_test altogether"
 948                skip_all="skip all tests in $this_test"
 949                test_done
 950        esac
 951done
 952
 953# Provide an implementation of the 'yes' utility
 954yes () {
 955        if test $# = 0
 956        then
 957                y=y
 958        else
 959                y="$*"
 960        fi
 961
 962        while echo "$y"
 963        do
 964                :
 965        done
 966}
 967
 968# Fix some commands on Windows
 969case $(uname -s) in
 970*MINGW*)
 971        # Windows has its own (incompatible) sort and find
 972        sort () {
 973                /usr/bin/sort "$@"
 974        }
 975        find () {
 976                /usr/bin/find "$@"
 977        }
 978        sum () {
 979                md5sum "$@"
 980        }
 981        # git sees Windows-style pwd
 982        pwd () {
 983                builtin pwd -W
 984        }
 985        # no POSIX permissions
 986        # backslashes in pathspec are converted to '/'
 987        # exec does not inherit the PID
 988        ;;
 989*)
 990        test_set_prereq POSIXPERM
 991        test_set_prereq BSLASHPSPEC
 992        test_set_prereq EXECKEEPSPID
 993        ;;
 994esac
 995
 996test -z "$NO_PERL" && test_set_prereq PERL
 997test -z "$NO_PYTHON" && test_set_prereq PYTHON
 998
 999# test whether the filesystem supports symbolic links
1000ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1001rm -f y
1002
1003# When the tests are run as root, permission tests will report that
1004# things are writable when they shouldn't be.
1005test -w / || test_set_prereq SANITY